import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;

/*This class does the basic arithmetic
  of complex numbers */

public class Complex {
    double x,y;
    
    public Complex() {
        this.x=0.0;
        this.y=0.0;
    } 
    
    public Complex(double x,double y) {
        this.x=x;
        this.y=y;
    }
    
    public Complex(Complex z) {
        this.x=z.x;
        this.y=z.y;
    }

    public Complex set(Complex z) {
        x=z.x;
        y=z.y;
        return this;
    }

    public static double norm(Complex z) {
        return Math.sqrt(z.x*z.x+z.y*z.y);
    }

    public Complex unit() {
	return unit(this);
    }
    
    public static Complex unit(Complex z) {
        double d=norm(z);
        return new Complex(z.x/d,z.y/d);
    }

    public static Complex plus(Complex z1,Complex z2) {
        return new Complex(z1.x+z2.x, z1.y+z2.y);
    }
    
    public static Complex negative(Complex z) {
	Complex w=new Complex(-z.x,-z.y);
	return(w);
    }

    public static Complex minus(Complex z1,Complex z2) {
        return new Complex(z1.x-z2.x, z1.y-z2.y);
    }
    

    public static Complex times(Complex z1,Complex z2) {
        return new Complex(z1.x*z2.x-z1.y*z2.y,
        z1.x*z2.y+z1.y*z2.x);
    }

    public Complex inverse() {
	return inverse(this);
    }
    

    public static Complex inverse(Complex z) {
        double d=z.x*z.x+z.y*z.y;
        return new Complex(z.x/d,-z.y/d);
    }


    public static double area(Complex a,Complex b,Complex c) {
	Complex z1=Complex.minus(a,c);
	Complex z2=Complex.minus(b,c);
	Complex z3=Complex.times(z1,z2.conjugate());
	return z3.y/2;
    }

    public static Complex divide(Complex z1,Complex z2) {
        return times(z1,inverse(z2));
    }
    
    public static Complex conjugate(Complex z) {
        return new Complex(z.x,-z.y);
    }

    public static double dist(Complex a,Complex b) {
        Complex z=minus(a,b);
        return(norm(z));
    }

    public Complex scale(double d) {
	return new Complex(d*x,d*y);
    }
    
    public static Complex interpolate(Complex[] z,double d) {
	 double x0=z[0].x;
	 double x1=z[1].x;
	 double y0=z[0].y;
	 double y1=z[1].y;
	 double x=(1-d)*x0+(d)*x1;
	 double y=(1-d)*y0+(d)*y1;
	 return new Complex(x,y);
    }

    /**taking a complex square root*/

    public static Complex sqRoot(Complex z) {
	double r=norm(z);
	double a=z.arg();
	Complex w=new Complex();
	r=Math.sqrt(r);
	a=.5*a;
        w.x=r*Math.cos(a);
        w.y=r*Math.sin(a);
        return(w);
    }

    public double arg(){
        return Math.atan2(y,x);
    }

    public double norm() {
	return norm(this);
    }

    public Complex  conjugate() {
	return conjugate(this);
    }


    public void print() {
	System.out.println("Complex: "+this.x+" "+this.y);
    }
}

