import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;

/**Documentation file*/


public class DocInstructions {

    public DocInstructions() {}


    public static void setup(DocumentCanvas D) {
    
	String S="4 Lines and a Rectangle\n";
	S=S+"by Rich Schwartz\n";
	S=S+"program started: 2 years ago\n";
	S=S+"Last updated:  1 August 2019\n";


	S=S+"\n\nPURPOSE:\n\n";
	S=S+"This program illustrates various results about the space of rectangles inscribed in 4 lines.  It is a companion to my paper on this topic.";

	    S=S+"\n\nOPERATING INSTRUCTIONS\n\n";

	    S=S+"First, here is some information about this text window. This window gives explanations for the rest of the program.  Drag the mouse over the text to scroll up or down. There is more text than what is now visible.  You can resize this window and  also change the font size.  If you press the question box at the top of the window, it will return this text to its initial location.";

	    S=S+"\n\nThis program is designed to work best with a 3 button mouse. On the two picture windows, buttoms 1 and 3 zoom in and out of the picture and button 2 generally selects a new point. If you don't have a 3 button mouse, you can use the keyboard buttons z,x,c to simulate the 3 buttons when you are operating any of the windows where you might want to rescale the picture.  This feature is slightly wonky, and you may need to first click in the window to restore the focus of the program to that window.";

	    S=S+"\n\nIf you press a question box, you can get more information about the features associated to the question box.";

	    S=S+"The two picture windows are resizeable.";

	    S=S+"\n\nMAIN FEATURES";

	    S=S+"\n\nAside from this text window, the program has 3 other windows.\n\n"; 

	    S=S+"Control panel";
	    S=S+"\n\nPicture Window";
	    S=S+"\n\nDial Window";
	    S=S+"\n\nI will describe the features on these windows one at a time.";

	S=S+"\n\nCONTROL PANEL:\n\n";

	S=S+"Here are the features of the control panel.";

	S=S+"\n\n--color selector. You can either choose some preset colors or else select the RBGT values. Here R is red, G is green, B is blue, and T is transparency.";
	
	S=S+"\n\n---object selectors.  The control panels titled basics, display, and dial control the display and rendering of various objects on the picture windows.  On each control panel, the left column of buttons (usually) controls the color of the displayed object and the right button (usually) controls whether the object is displayed or not. You can change the color by selecting a color on the color selector and then clicking the relevant left button.";
	
	S=S+"\n\n--line selection:  There are various ways to move the 4 lines in the picture window.  This panel controls which one you use.";
	S=S+"\n\n--grab button: This lets you store in memory the current configuration of 4 lines.  When the program opens, the initial config is stored.";
	S=S+"\n\n--send button: This lets you replace the current configuration of 4 lines with the one stored in memory.  you can use this as a kind of reset.";
	S=S+"\n\n--cycle: This cyclically permutes the 4 lines.";
	S=S+"\n\n--clear:  Some of the features on the dial display window cause the dial window to store and plot the locations of some of the points. This button clears this plot.";
	S=S+"\n\n--interval thickness: This controls the width of the display of the excluded intervals (from the display control panel).";
	S=S+"\n\n--rectangle center: This controls the size of the rectangle centers.";

	    S=S+"\n\nPICTURE WINDOW";

	    S=S+"\n\nThis window displays the various Euclidean objects from the theorems in the paper, such as the 4 lines and the inscribed rectangle.  You can see what is displayed by clicking on the buttons of the control panel and seeing what pops up.  The main way you interact with the window is by selecting the lines.  There line selection option gives you several ways to do this.  In all cases, you use mouse button 2 (either click or drag) to make the changes.  You can also use key-c in place of mouse bytton 2 if you don't have a 3 button mouse.  Here are the modes:";

	    S=S+"\n\npoly vertices:  This is the basic option.  We can think of the 4 lines as extending the sides of a quadrilateral.  In this mode, you move the vertices of the quadrilateral and the lines go along for the ride.";

	    S=S+"\n\ntranslate diags:  With this option you can grab the diagonals of the configuration and drag them around.  This relates to the diagonal property mentioned in Chapter 3 of the paper.";

	    S=S+"\n\nswivel options: Assuming that you have selected an inscribed rectangle in the dial window, swivel option 1 will allow you to swivel line 1 around vertex 1 of the selected rectangle. you should first turn on the rectangle button on the diaplay panel and then select a rectangle.";

	    
	    S=S+"\n\nDIAL WINDOW";

	    S=S+"\n\nThis window lets you select the slope or the aspect ratio of the inscribed rectangle.  There are two dials, an inner dial or an outer dial.  The inner dial controls the aspect ratio.  The outer dial controls the slope.  The way to use these dials is to click/drag the mouse, using button-2 (or key-c) in the thin black annuli.   When you do this, a red or blue rectangle appears in the center of the window. This rectangle matches the aspect ratio and slope of the corresponding inscribed rectangle.   The various markers around the window indicate the aspect ratios or slopes of special rectangles. We keep track of the rectangles of slope 0,1,-1,\u221E, and also the omitted aspect ratios and omitted slopes from Theorems 2 and 3.  To see the dial in action, turn on the rectangle display option on the display panel.";


        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;
    }


    public static void basics(DocumentCanvas D) {

	String S="basics:\n\nThis controls various objects having to do with the selection of lines.  You can either control the lines by moving the vertices, by translating the diagonals around, or by swiveling around each line.  When you turn on and off various features you can make the operations more clear.";
    
        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;
    }


    public static void display(DocumentCanvas D) {
	String S="";
	
	S=S+"display:\n\nThis controls other features on the picture window.  Here are the options.";

	S=S+"\n\n--The interval buttons control the display of certain segments on the lines related to the branch points discussed in Theorem 5.  These intervals are such that no point in the interval is the vertex of an inscribed rectang;e. They are the excluded intervals, so to speak.";

	S=S+"\n\n--The hyperbola.  This is the hyperbola from Theorem 1.  It is the locus of centers of inscribed rectangles.";

	S=S+"\n\n--The rectangle: This shows the instribed rectangle.";

	S=S+"\n\n--partner rectangle: Side 1 of the first rectangle is perpendicular to side 1 of the partner rectangle.  This illustrates Theorem 4.";
	
	S=S+"\n\n--rectangle chain: This illustrates the configuration theorem which is a corollary of Theorem 5.";


        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;
    }

    
    public static void dial(DocumentCanvas D) {
	String S="";
	S=S+"dial display:\n\nThis controls features on the dial window.  The purpose of the dial window is to specify either the aspect ratio or the slope of the inscribed rectangle. Here are the features";

	S=S+"\n\n---hyp buttons:  These  deal with the projective tangent bundle construction in Chapter 3 of the paper.";

	S=S+"\n\n---AR markers:  These turn on and off markers which indicate how to specify the rectangles of aspect ratio -1, 0, 1, \u221E.";

	S=S+"\n\n--record buttons: These tell the computer to save the locations of the hyperbolic geometry objects as you move the lines around.  I used these to deduce the various properties of the unit tangent bundle map listed at the end of Chapter 3.  You should just ignore these.";

	S=S+"\n\n---Swivel property: This turns on a display which has to do with the final property listed in the paper, the swivel property. This option only works when you have selected one of the swivel options on the line selection control panel.";
	
        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;
    }



}
