import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class PictureCanvas extends ScaleCanvas implements MouseListener, MouseMotionListener, KeyListener {
    Manager M;
    int CHOICE;
    Segment[] S=new Segment[4];  //these are the lines
    Segment[] SS=new Segment[4];
    PolygonWrapper R1,R2;
    PolygonWrapper POLY;
    boolean DRAG;
    boolean SPECIAL;
    Point CURSOR;
    int COUNT;
    Output OUT;
    boolean DONE;
    PolygonWrapper[] MEM=new PolygonWrapper[6];
    int MEMCOUNT;

     public PictureCanvas() {
	 addMouseListener(this);
	 addKeyListener(this);
	 addMouseMotionListener(this);
	 setScales(300,300,100);
         setRectangles();
         setSegments();	
	 COUNT=0;
	 CURSOR=new Point();
	 SPECIAL=false;
	 OUT=new Output("Output/graph");
	 MEMCOUNT=0;

     }

    public void setRectangles() {
	POLY=new PolygonWrapper();
	POLY.z[0]=new Complex(1,.4);
	POLY.z[1]=new Complex(2,1.5);
	POLY.z[2]=new Complex(0,2);
	POLY.z[3]=new Complex(.3,1.2);
	R1=POLY.diagonal(0);
	R2=POLY.diagonal(1);
    }

    public void setSegments() {
	for(int i=0;i<4;++i) S[i]=new Segment(R1.z[i],R2.z[i]);
    }


   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      drawBG(g);
      drawLines(g);
      drawRectangle(g);
      drawRectangle2(g);
      drawRectangle3(g);
      drawTurns(g);
      drawDiagonals(g);
      drawQuad(g);
      drawCenters(g);
      drawMem(g);
    
   }


    /**This draws the background*/
    public void drawBG(Graphics2D g) {
	Color C=Color.black;
	try{
	    C=M.C.BASICS.M[0].C;
	}
        catch(Exception e) {}
	g.setColor(C);
        g.fillRect(0,0,getWidth(),getHeight()); 
    }


    /**This draws the 4 lines*/
    public void drawLines(Graphics2D g) {
	Color[] C=new Color[4];
	for(int i=0;i<4;++i) C[i]=M.C.BASICS.M[i+1].C;
	for(int i=0;i<4;++i) {
	    if(M.C.BASICS.L[i+1].on==1) S[i].render(g,this,C[i],1);
	}
    }



    public void drawCenters(Graphics2D g) {
  	if(M.C.DISPLAY.L[5].on==0) return;
	Vector[] V=new Vector[5];
	for(int i=0;i<5;++i) {
           Complex[] u=SquareLine.getRectangle(.25*i+.1,S);
	   PolygonWrapper P=new PolygonWrapper(u);
	   Complex z=P.center();
	   V[i]=new Vector(z);
	}
	double[] d=Conic.toConic(V[0],V[1],V[2],V[3],V[4]);
	Segment[] A=getDiagonals();
	double x=Segment.crossRatio(S);
	Complex[] diag={new Complex(x,0),A[0].center(),A[1].center()};
	Path2D.Double[] p=Conic.toPath(d,diag);
	if(p==null) return;
	p[0]=transform(p[0]);
	g.setColor(M.C.DISPLAY.M[5].C);
	g.draw(p[0]);
    }

    
    public Segment[] getDiagonals() {
	Complex z01=Segment.cross(S[0],S[1]);
	Complex z23=Segment.cross(S[2],S[3]);
	Complex z12=Segment.cross(S[1],S[2]);
	Complex z30=Segment.cross(S[3],S[0]);
	Segment A=new Segment(z01,z23);
	Segment B=new Segment(z12,z30);
	Segment[] C={A,B};
	return C;
    }

    /**This draws the two rectangle guides for the program*/

    public void drawDiagonals(Graphics2D g) {
	g.setStroke(new BasicStroke(2));
	Path2D.Double gp=new Path2D.Double();
	gp=R1.toPath();
	gp=transform(gp);
	g.setColor(M.C.BASICS.M[5].C);
	if(M.C.BASICS.L[5].on==1) g.draw(gp);
	gp=R2.toPath();
	gp=transform(gp);
	g.setColor(M.C.BASICS.M[6].C);
	if(M.C.BASICS.L[6].on==1) g.draw(gp);
	g.setStroke(new BasicStroke(1));
    }

    /**This draws the quadrilateral*/
    public void drawQuad(Graphics2D g) {
	if(M.C.BASICS.L[7].on==0) return;
	Path2D.Double gp=POLY.toPath();
	gp=transform(gp);
	g.setColor(M.C.BASICS.M[7].C);
	g.draw(gp);
    }
        
    /**This decides if there is a special component defined
       by rectangle guides having the same aspect ratio*/

    public boolean specialComponent() {
	double r1=R1.aspectRatio();
	double r2=R2.aspectRatio();
	if(Math.abs(r1-r2)<.0000000001) return true;
	return false;
    }


    /**This draws the inscribed rectangle*/
    
    public void drawRectangle(Graphics2D g) {
	if(M.C.DISPLAY.L[6].on==0) return;
	double a=M.S.getAspectValue(S);
	Double A=Double.valueOf(a);
        if(A.isNaN()==true) a=1;
	
	PolygonWrapper X=new PolygonWrapper(SquareLine.getRectangle(a,S));
	Path2D.Double gp=X.toPath();
	gp=transform(gp);
	if(a<=0) g.setColor(new Color(255,50,0,200));
	if(a>=0) g.setColor(new Color(0,50,255,200));
	g.fill(gp);
	g.setColor(Color.white);
	g.draw(gp);
	Complex z=X.center();
	double r=Math.pow(.5,M.C.POINT[1].val);
	fillPoint(g,z,r,Color.white,32);
    }

    /**This draws the partner rectangle: line 2 of the partner 
       has the same slope as line 1 of the original.*/
    
    public void drawRectangle2(Graphics2D g) {
	if(M.C.DISPLAY.L[7].on==0) return;
	double a=M.S.getAspectValue2(S);
	PolygonWrapper X=new PolygonWrapper(SquareLine.getRectangle(a,S));
	Path2D.Double gp=X.toPath();
	gp=transform(gp);
	if(a<=0) g.setColor(new Color(255,50,0,200));
	if(a>=0) g.setColor(new Color(0,50,255,200));
	g.fill(gp);
	g.setColor(Color.white);
	g.draw(gp);
	Complex z=X.center();
	double r=Math.pow(.5,M.C.POINT[1].val);
	fillPoint(g,z,r,Color.white,32);
    }

    public void drawRectangle3(Graphics2D g) {
	if(M.C.DISPLAY.L[7].on==0) return;
	double a1=M.S.getAspectValue(S);
	PolygonWrapper X1=new PolygonWrapper(SquareLine.getRectangle(a1,S));
	Complex z1=X1.center();
	double a2=M.S.getAspectValue2(S);
	PolygonWrapper X2=new PolygonWrapper(SquareLine.getRectangle(a2,S));
	Complex z2=X2.center();
	Path2D.Double gp=new Path2D.Double();
	gp.moveTo(z1.x,z1.y);
	gp.lineTo(z2.x,z2.y);
	gp=transform(gp);
	g.setColor(Color.white);
	g.draw(gp);
    }





    

    /**This draws the turning points of the system. These
       are the points when the map to the rectangle vertex
       is not a regular map. That is, the point turns around
       on the line as the aspect ratio changes*/

    public void drawTurns(Graphics2D g) {
	int thick=M.C.POINT[0].val;
	double r=Math.pow(.5,thick);
	for(int i=0;i<4;++i) {
	    Complex[] TURN=SquareLine.getTurns(i,S);
	    if(TURN!=null) {
		Path2D.Double gp=new Path2D.Double();
		gp.moveTo(TURN[0].x,TURN[0].y);
		gp.lineTo(TURN[1].x,TURN[1].y);
		gp=transform(gp);
		g.setStroke(new BasicStroke(thick));
		g.setColor(M.C.DISPLAY.M[i+1].C);
		if(M.C.DISPLAY.L[i+1].on==1) g.draw(gp);
	    }
	}
    }


    public void alterLines() {
	int m=M.C.MOTION.mode;
	if(m==0) moveVertices();
	if(m==1) translateDiagonals();
	if(m==2) swivel(3);
	if(m==3) swivel(0);
	if(m==4) swivel(1);
	if(m==5) swivel(2);
    }


    /**line motion: use diagonals*/

    public void moveVertices() {
	int t=POLY.nearestPoint(SOURCE);
	POLY.z[t]=new Complex(SOURCE);
	R1=POLY.diagonal(0);
	R2=POLY.diagonal(1);
	setSegments();
    }
    
    public void translateDiagonals() {
	double d1=Complex.dist(SOURCE,R1.center());
	double d2=Complex.dist(SOURCE,R2.center());
	if(d1<d2) R1=R1.translate(SOURCE);
	else R2=R2.translate(SOURCE);
	POLY=PolygonWrapper.fromDiagonals(R1,R2);
	setSegments();
    }
    
    public void swivel(int k) {
	double a=M.S.getAspectValue(S);
	PolygonWrapper X=new PolygonWrapper(SquareLine.getRectangle(a,S));
	POLY=POLY.swivel(k,X.z[(k+1)%4],SOURCE);
	R1=POLY.diagonal(0);
	R2=POLY.diagonal(1);
	setSegments();
    }
    

    /**Mouse commands*/

    public void mousePressed(MouseEvent e) { 
	MouseData J=MouseData.process(e);
	if(J.mode==2)  {
            SOURCE=unTransform(J.X);
	}
    }

    public void mouseClicked(MouseEvent e) { 
	MouseData J=MouseData.process(e);
        if(J.mode==1)  scaleUp(J.X,0);
        if(J.mode==3)  scaleUp(J.X,1);
	if(J.mode==2) alterLines();
	M.repaint();
    }

    public void doMouseClick(int mode) { 
        if(mode==1)  scaleUp(CURSOR,0);
        if(mode==3)  scaleUp(CURSOR,1);
	if(mode==2)  alterLines();
	M.repaint();
    }

     public void mouseReleased(MouseEvent e) {	 
     }

     public void mouseEntered(MouseEvent e) {
	 requestFocus();
     }

     public void mouseExited(MouseEvent e) {}   

     public void mouseMoved(MouseEvent e) {
	MouseData J=MouseData.process(e);
	if(DRAG==true) doMouseDrag();
	 CURSOR=J.X;
     }  
     public void mouseDragged(MouseEvent e) {
	MouseData J=MouseData.process(e);
        if(J.mode!=2) return;
          SOURCE=unTransform(J.X);
	  alterLines();
	  COUNT=0;
	  M.repaint();
     }

     public void doMouseDrag() {
          SOURCE=unTransform(CURSOR);
	  alterLines();
	  COUNT=0;
	  M.repaint();
     }



    public void keyPressed(KeyEvent e) {
	char ch=e.getKeyChar();
       	if(ch=='x') DRAG=true;
    }

    public void keyReleased(KeyEvent e) {
	DRAG=false;
    }

    public void keyTyped(KeyEvent e) {
	char ch=e.getKeyChar();
       	int test=-1;
       	if(ch=='z') test=1;   
       	if(ch=='x') test=2;   
       	if(ch=='c') test=3;
	if(ch=='v') doMem();
	if(ch=='b') drawPixForPaper1();
	if(ch=='n') drawPixForPaper2();
	if(ch=='q')  MEMCOUNT=0;

       	doMouseClick(test); 
       	M.repaint();
    }




    public void doMem() {
	double a=M.S.getAspectValue(S);
	Double A=Double.valueOf(a);
        if(A.isNaN()==true) a=1;
	PolygonWrapper X=new PolygonWrapper(SquareLine.getRectangle(a,S));
	MEM[MEMCOUNT]=X;
	++MEMCOUNT;
    }

    public void drawMem(Graphics2D g) {
	if(M.C.DISPLAY.L[8].on==0) return;
	double a=M.S.getAspectValue(S);
	Color[] COL1={new Color(50,80,255,80),new Color(255,0,0,80),new Color(200,0,255,80),new Color(0,200,0,80)};
	Color[] COL2={new Color(50,80,255),new Color(255,0,0),new Color(200,0,255),new Color(0,200,0)};
	PolygonWrapper[] P=new PolygonWrapper[4];
	P[0]=new PolygonWrapper(SquareLine.getRectangle(a,S));
	for(int i=0;i<3;++i) {
	    a=SquareLine.getConjugateRatio(i,a,S);
	    P[i+1]=new PolygonWrapper(SquareLine.getRectangle(a,S));
	}
	for(int i=0;i<4;++i) {
	    MEM[i]=P[i];
	    Path2D.Double gp=P[i].toPath();
	    gp=transform(gp);
	    g.setColor(COL1[i]);
	    g.fill(gp);
	    g.setColor(COL2[i]);
	    g.draw(gp);
	}
	MEMCOUNT=4;

	//Complex[] Q=new Complex[4];
	//for(int i=0;i<4;++i) Q[i]=new Complex(P[i].z[i]);
	//PolygonWrapper QQ=new PolygonWrapper(Q);
	//Path2D.Double p=QQ.toPath();
	//p=transform(p);
	//g.setColor(Color.white);
	//g.draw(p);
    }
    
    /**This is just for the paper*/

    public void drawPixForPaper1() {

	double[] AA={-.85,.38,.44};
	Color[] CC={new Color(200,200,200),new Color(150,150,150),new Color(120,120,120)};
	for(int i=0;i<AA.length;++i) {
	    PolygonWrapper X=new PolygonWrapper(SquareLine.getRectangle(AA[i],S));
	   Path2D.Double gp=X.toPathEmpty();
	   OUT.polyWrite(gp,CC[i],CC[i]);
	}

	Color GR=new Color(110,110,110);
	for(int i=0;i<4;++i) {
	    Path2D.Double gp=S[i].toPath(10);
	    OUT.polyWrite(gp,GR,GR);
	}
	
	Vector[] V=new Vector[5];
	for(int i=0;i<5;++i) {
           Complex[] u=SquareLine.getRectangle(.25*i+.1,S);
	   PolygonWrapper P=new PolygonWrapper(u);
	   Complex z=P.center();
	   V[i]=new Vector(z);
	}
	double[] d=Conic.toConic(V[0],V[1],V[2],V[3],V[4]);
	Segment[] A=getDiagonals();
	double x=Segment.crossRatio(S);
	Complex[] diag={new Complex(x,0),A[0].center(),A[1].center()};
	Path2D.Double[] p=Conic.toPath(d,diag);
	OUT.lineWrite(p[0],Color.black);
	DONE=true;
    }


    public void drawPixForPaper2() {
	Color CC=new Color(180,180,180);
	for(int i=0;i<MEMCOUNT;++i) {
	   Path2D.Double gp=MEM[i].toPathEmpty();
	   OUT.polyWrite(gp,CC,new Color(130,130,130));
	}

	Color GR=new Color(0,0,0);
	for(int i=0;i<4;++i) {
	    Path2D.Double gp=S[i].toPath(20);
	    OUT.polyWrite(gp,GR,GR);
	}
    }



    
}

